package gecco.game.dke;

/**
 * DelayAction.java
 *
 *
 * Created: Wed Nov 27 15:34:05 2002
 *
 * @author <a href="mailto:m-8028@M-8028"></a>
 * @version
 */

import gecco.server.core.*;


public abstract class DelayAction extends Action {

    double delay = 0;
    boolean firstRun = true;

    public DelayAction(){
	super();
    }

    /**
     * Use this constructor if you just want to throw the delay into the queue
     *
     * @param delay a <code>double</code> value
     */
    public DelayAction (int unitHandle, double delay){
	this();
	this.delay = delay;
	int actionHandle = gecco.server.core.Action.getNewActionHandle();
	initiate(actionHandle, unitHandle);
	ReferenceHolder.getActionProcessor().initiateAction(Def.getSystemRoleName(), this);
	setInstantaneous(false);
    }
    public DelayAction (int unitHandle, int argUnitHandle, double delay){
	this();
	this.delay = delay;
	int actionHandle = gecco.server.core.Action.getNewActionHandle();
	initiate(actionHandle, unitHandle, argUnitHandle);
	ReferenceHolder.getActionProcessor().initiateAction(Def.getSystemRoleName(), this);
	setInstantaneous(false);
    }

    public void initiate(int _actionHandle, int _unitHandle, int _argUnitHandle, double delay){
	super.initiate(_actionHandle, _unitHandle, _argUnitHandle);
	this.delay = (double)delay;
	setInstantaneous(false);
    }
    
}// DelayAction
