package gecco.game.dke3;

import gecco.server.core.ReferenceHolder;
import gecco.game.dke.AutomatonImpl;
import gecco.server.visibility.Point;
import gecco.game.dke.GameEventPoint;



/**
 * RouteFinderDKE3.java
 *
 *
 * Created: Mon Jan 26 16:39:24 2004
 *
 * @author <a href=mailto:hans.sandstrom@fhs.mil.se> Hans Sandstrm </a>
 * @version 1.0
 */
public class RouteFinderDKE3 extends gecco.game.dke.RouteFinder {
 
    public static boolean isBeachHeadRouteOpen(BeachHeadPoint start, BeachHeadPoint end){
	Point startPoint = new Point(start.getIntX(), start.getIntY());
	Point endPoint = new Point(end.getIntX(), end.getIntY());
	AutomatonImpl startAutomaton = (AutomatonImpl)ReferenceHolder.getAutomatonMap().
	    getAutomaton(startPoint.x, startPoint.y);
	AutomatonImpl endAutomaton = (AutomatonImpl)ReferenceHolder.getAutomatonMap().
	    getAutomaton(endPoint.x, endPoint.y);
	boolean testForLastVisitor = true;
	int force = start.getOwner();
	
	int maxAllowedDistance = start.getMaxDistance();
      
	Point[] route = findRoute(startAutomaton, startPoint, endAutomaton, endPoint,
				  testForLastVisitor, force);
	if (route == null) {
	    // Debug info
	    ReferenceHolder.out.println("No route found for beachHead "+ start.getName());
	    return false; // no route found
	}else {
	    if (route.length > maxAllowedDistance) {
		// Debug info
		ReferenceHolder.out.println("Route to long for beachHead "+ start.getName());
		return false; //
	    } 
	}
	// Debug info
	ReferenceHolder.out.println("Route found for beachHead "+ start.getName());
	return true;
    }

    public static boolean isGameEventPointRouteOpen(GameEventPoint p1, GameEventPoint p2){
	int ownerP1 = p1.getOwner();
	if (ownerP1 != p2.getOwner()) {
	    return false;
	}
	Point posP1 = new Point(p1.getIntX(), p1.getIntY());
	Point posP2 = new Point(p2.getIntX(), p2.getIntY());
	return isRouteOpen(posP1, posP2, ownerP1);
    }

} // RouteFinderDKE3
